/// <reference types="react" />
import * as React from 'react';
import * as data from '../data';
export interface FormBuilderIDGenerator {
    (): string;
}
export interface IFormBuilderProps {
    fields: data.IField[];
    registry: data.FieldRegistry;
    onChange: (fields: data.IField[], change: data.IFieldChange) => void;
    onError?: (error: {
        [id: string]: any;
    }) => void;
    onFieldEditing: (field: data.IField) => void;
    onBeforeAddField?: (field: data.IField) => boolean;
    onBeforeDeleteField?: (field: data.IField) => boolean;
    onBeforeEditField?: (field: data.IField) => boolean;
    editButton?: data.IEditableControlSource;
    deleteButton?: data.IEditableControlSource;
    idGenerator?: FormBuilderIDGenerator;
    editingFieldId: string;
}
export declare class FormBuilder extends React.Component<IFormBuilderProps, {}> {
    private builderError;
    constructor(props: IFormBuilderProps);
    private onEditField(field);
    private onDeleteField(index);
    private onDrop(target, source, didDrop);
    private ensureID(field);
    private onFieldChanged(field, index, change);
    private onFieldError(field, index, error);
    private renderField(field, index);
    render(): JSX.Element;
}
